/******************************************************************************* 
	Paper: Economic Inclusion through Entrepreneurship: Evidence on Building 
		   Skills for Women
	Title: Impact Evaluation Analysis and Tables Creation
	Authors: Megan Lang and Julia Seither
	RA: Maria Sofia Casabianca

	Description: This Do-file runs all the do files.
	
	STATA version: 18

	Date: Oct 25 - 2024 (Last Update)										 
*******************************************************************************/


// Main Do File to Run All Code Files for "Building Skills Uganda Replication"

// Clear memory and set up environment
clear all
set more off

// Define the global path to the folder containing the .do files
global path "C:/Temp/Building Skills Uganda Replication/Code/"
sysdir set PLUS "$path/ado"

// Run individual scripts using the global path
do "$path/Table 1-7.do"
do "$path/Figure 1-2.do"
do "$path/Appendix B Figures.do"
do "$path/Appendix B Tables.do"
do "$path/Appendix C Tables.do"
do "$path/Appendix D Tables.do"



// Notify when done
display "All scripts executed successfully!"
